        ;      ***************************************
        ;      ***  Kuehlmittel & Spindel-Antrieb  ***
        ;      *****  Interrupt enable & disable  ****
        ;      ***************************************
        ;
        ; Eingangbedingungen von EAX:  0 = Keine Aktion (init)
        ;                              1 = Spindelantrieb - FF
        ;                              2 = Kuehlmittel - FF
        ;                              3 = Interrupts OFF
        ;                              4 = Interrupts ON
        ;
        TITLE kmint
        .Model Large
        .386
        .code
        ;
spkm    proc
        push    di              ; Save di
        push    si              ; Save si
        push    sp              ; Save sp
        ;
        cmp     eax,0           ; Init ?
        jnz     spindl          ; NO, check next !
        mov     al,0            ; SET = INIT
        call    doio
        jmp     abo   
        ;
spindl: cmp     eax,1           ; Spindelantrieb ?
        jne     kuehl           ; NO, check next ! 
        mov     al,88h          ; SET = SPINDELANTRIEB
        call    doio            ;\            
        sub     al,al           ;\\
        call    doio            ;\\\
        jmp     abo             ; \\\\ SET-sequenze
        ;
kuehl:  cmp     eax,2           ; Kuehlmittelantrieb ?
        jne     ioff            ; NO, check next !
        mov     al,90h          ; SET = KUEHLMITTELANTRIEB
        call    doio            ;\            
        sub     al,al           ;\\
        call    doio            ;\\\
        jmp     abo             ; \\\\ SET-sequenze
        ;
ioff:   cmp     eax,3           ; Interrups off ?
        jne     ion             ; NO, check next !
        cli                     ; Disable Interrupts
        jmp     abo             ;  and exit.
        ;
ion:    sti                     ; Enable Interrupts !      
        ;
abo:    pop     sp              ; Restore sp - register
        pop     si              ; Restore si - register
        pop     di              ; restore di - register
        ret
spkm    endp
        ;
doio    proc
        mov     dx,378H         ; Base-Address
        out     dx,al           ; Set CSR-Output-register
        inc     dx              ; POINT to CSR - controll-register
        inc     dx              ;   "    "    "        "
        ;########################
        mov     al,0DH          ; al <--"0"
        out     dx,al           ; Strobe -> LOW <<<---bernahme
        dec     al              ; al <--"1"
        out     dx,al           ; Strobe -> HIGH
        ;########################
        ret
doio    endp
        ;
        end
