        ; **************************************************************
        ; *** 3D-Stepping Procedure - For Intel 386  (c) R.Heuberger ***
        ; **************************************************************
        ; ***         Version for the SHD - ADAPTER -BOX             ***
        ; **************************************************************
        ;      Mit Stop & Recover-Stepp-Routinen, fertig 16-MAR-93
        ; 
        ;       Eingangs-Bedingungen:  X-Schritte: EAX
        ;                              Y-Schritte: EBX
        ;                              Z-Schritte: ECX
        ;                Vorschub-Geschwindigkeit: EDX
        ;
        ; Defenitions - local buffer ( offsets ) :  
        ;  di[0]  = PHYSICAL-xstepp      di[4]  = PHYSICAL-ystepp 
        ;  di[8]  = PHYSICAL-zstepp      di[12] = Backup ecx
        ;  di[16] = Backup al            di[20] = Backup al
        ;  di[24] = step_M               di[28] = step_1
        ;  di[32] = step_2               di[36] = Stepword, step_M
        ;  di[40] = Stepword, step_1     di[44] = Stepword, step_2
        ;  di[48] = Temp & Main-Speed    di[52] = err_1
        ;  di[56] = kerr_1               di[60] = gerr_1
        ;  di[64] = err_2                di[68] = kerr_2
        ;  di[72] = gerr_2               
        ;  di[76] = Limit switching to trapezoidal mode ( mac_a% )
        ;  di[80] = Trapezoidal step value ( mac_b% )
        ;  di[84] = FLAG, 1=Use trapezoidal mode.  
        ;  di[88] = Will contain calulated Limit.         
        ;  di[92] = Calculated number of necessary steps. 
        ;  di[96] = Loop-Count.
        ;  di[100] = eax - SAVE
        ;  di[104] = ebx - SAVE
        ;  di[108] = ecx - SAVE
        ;  di[112] = Storage & Save for ebx ( d2 ) , emercency STOP !
        ;  di[116] = Storage & Save for esi ( d7 ) , emercency STOP !
        ;
        ;
        TITLE 8255
        .Model Large
        .386
        .code
        ;
stepp   proc
        push    di              ; Save di
        push    si              ; Save si
        push    sp              ; Save sp
        ;
        ;mov     eax,4000d       ; $- DEBUG purpose, xstepp% -$
        ;mov     ebx,2000d       ; $- DEBUG purpose, ystepp% -$
        ;mov     ecx,1000d       ; $- DEBUG purpose, zstepp% -$
        ;mov     edx,1600d       ; $- DEBUG purpose, speed%  -$
        ;
        and     eax,eax         ; IF   xstepp value not equal "0"
        jne     sbegin          ; THEN start program.
        and     ebx,ebx         ; IF   ystepp value not equal "0"
        jne     sbegin          ; THEN start program.
        and     ecx,ecx         ; IF   zstepp value equal "0"
        je      abo             ; THEN exit.
        ;
sbegin: lea     di, OFFSET lobuf  ; di = Pointer to local buffer.
        mov     cs:[di]+104,ebx     ; Save ebx-Register
        mov     cs:[di]+108,ecx     ; Save ecx-Register
        mov     cs:[di]+12,edx     ; Save speed value local ( 32 bit ).
        ;
        ;mov     cs:[di]+76,DWORD PTR 3000d    ; $- DEBUG > A-PARAM -$
        ;mov     cs:[di]+80,DWORD PTR 15       ; $- DEBUG > B-PARAM -$
        ;
        add     cs:[di],eax       ;-; PHYSICAL: Calculate current X-Position.
        add     cs:[di]+4,ebx     ;-; PHYSICAL: Calculate current Y-Position.
        add     cs:[di]+8,ecx     ;-; PHYSICAL: Calculate current Z-Position.
        ;
        and     eax,eax         ; Test, = Find X-direction.
        js      Xtopos          ;  X-DIR = backwards.
        mov     cs:[di]+100,eax  ; SAVE eax-Register !
        mov     al,00001000b    ; Set X - forward bit
        jmp     Chey            ; 
Xtopos: neg     eax             ; Make X-Step posetive !
        mov     cs:[di]+100,eax  ; SAVE eax-Register !
        mov     al,00000000b    ; Clear - al, = X Backwards.
Chey:   and     ebx,ebx         ; Test, = Find Y-diriction.
        js      Ytopos          ; Y-DIR  already done.
        or      al,00010000b    ; SET Y - forward bit.
        jmp     Chez
Ytopos: neg     ebx             ; Make Y - Step posetive !
        mov     cs:[di]+104,ebx  ; SAVE ebx-Register AGAIN!
Chez:   and     ecx,ecx         ; Test, = Find Z-direktion.
        js      Ztopos          ; Z-DIR already done.
        or      al,00100000b    ; Set Z - forward bit.
        jmp     Sdir            ; 
Ztopos: neg     ecx             ; Make Z - Step posetive !
        mov     cs:[di]+108,ecx  ; SAVE ecx-Register AGAIN!
        ;
Sdir:   mov     cs:[di]+16,al   ; Save al - Register
        mov     cs:[di]+20,al   ; Save al - Register 
        mov     dx,378H         ; Base-Address
        out     dx,al           ; Set CSR-Output-register = Axis directions.
        inc     dx              ; POINT to CSR - controll-register
        inc     dx              ;   "    "    "        "
        mov     al,1            ; al <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW
        ; 
        ;   - Find axis_M, = axis with greatest movement.
        ;   - Check & order deltas, axis_M, axis_1, axis_2.
        ;
        mov     eax,cs:[di]+100      ; RESTORE eax - register  
        cmp     ebx,eax              ; Compare Xstepp with Ystepp.
        jg      YgtX                 ; Ystepp > Xstepp
XgtY:   cmp     ecx,eax              ; Compare Xstepp with Zstepp.
        jg      ZgtXY                ; Zstepp > Xstepp
        mov     cs:[di]+24,eax       ;-> X-axis has greatest movement! 
        mov     cs:[di]+28,ebx       ;\
        mov     cs:[di]+32,ecx       ;\\      
        mov     al,00000001b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if X-axis
        mov     al,00000010b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000100b         ;//
        mov     cs:[di]+44,al        ;/
        jmp     Cabre                ;
YgtX:   cmp     ecx,ebx              ; Compare Ystepp with Zstepp
        jg      ZgtXY                ; Zstepp > Ystepp
        mov     cs:[di]+24,ebx       ;-> Y-axis has greatest movement!
        mov     cs:[di]+28,eax       ;\
        mov     cs:[di]+32,ecx       ;\\       
        mov     al,00000010b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if Y-axis
        mov     al,00000001b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000100b         ;//
        mov     cs:[di]+44,al        ;/
        jmp     Cabre                ;
ZgtXY:  mov     cs:[di]+24,ecx       ;-> Z-axis has greatest movement!
        mov     cs:[di]+28,eax       ;\
        mov     cs:[di]+32,ebx       ;\\       
        mov     al,00000100b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if Z-axis
        mov     al,00000001b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000010b         ;//
        mov     cs:[di]+44,al        ;/
        ;
        ;
        ;  ***  Calculate values for Bresenham's Algorithm. ***
        ;        Note: eax-register already saved.. index 0
        ;
Cabre:  mov     eax,cs:[di]+24          ; Get delta_M      =>eax
        mov     ebx,cs:[di]+28          ; Get delta_1      =>ebx
        mov     ecx,cs:[di]+24          ; Backup  delta_M  =>ecx
        sal     ebx,1                   ; delta_1 = delta_1 * 2
        sal     eax,1                   ; delta_M = delta_M * 2
        mov     cs:[di]+56,ebx          ; SAVE "kerr_1",( prepare,if err_1>0 )
        mov     cs:[di]+48,ebx          ; Backup delta_1 => "temp1" 
        sub     ebx,ecx                 ; err_1 = 2*delta_1-delta_M
        mov     cs:[di]+52,ebx          ; SAVE err_1
        mov     ebx,cs:[di]+48          ; RECALL delta_1 temp1 =>ebx
        sub     ebx,eax                 ; "gerr_1" = 2*delta_1 - 2*delta_M
        mov     cs:[di]+60,ebx          ; SAVE "gerr_1"
        ; ------------------------------;
        mov     eax,cs:[di]+24          ; Get delta_M      =>eax
        mov     ebx,cs:[di]+32          ; Get delta_2      =>ebx
        mov     ecx,cs:[di]+24          ; Backup  delta_M  =>ecx
        sal     ebx,1                   ; delta_2 = delta_2 * 2
        sal     eax,1                   ; delta_M = delta_M * 2
        mov     cs:[di]+68,ebx          ; SAVE "kerr_2",( prepare,if err_1>0 )
        mov     cs:[di]+48,ebx          ; Backup delta_2 => "temp1" 
        sub     ebx,ecx                 ; "err_2" = 2*delta_2-delta_M
        mov     cs:[di]+64,ebx          ; SAVE "err_2"
        mov     ebx,cs:[di]+48          ; RECALL delta_2 temp1 =>ebx
        sub     ebx,eax                 ; "gerr_2" = 2*delta_2 - 2*delta_M
        mov     cs:[di]+72,ebx          ; SAVE "gerr_2"
        ;
        ;
        ;     Check and decide to use trapezoidal velocity mode.
        ;
        mov     ebx,cs:[di]+76          ; Get velocity treshold ->eax
        sub     ebx,cs:[di]+80          ; Align treshold with mac_b& !
        cmp     ebx,cs:[di]+12          ; IF   velocity limit reached.
        jg      Rampe                   ; THEN check to use trapezoidal mode.
Noramp: mov     cs:[di]+84,DWORD PTR 0  ; ELSE clear FLAG,
        jmp     Mlpre                   ;      start non trapezoidal mode.
                                        ;
Rampe:  mov     eax,cs:[di]+24          ; Get number of steps ->eax
        cmp     eax,40d                 ; If   it makes sence using trapezoid.
        jg      Doramp                  ; THEN branch and prepare parameter
        mov     ebx,cs:[di]+76          ; ELSE corect velocity value
        mov     cs:[di]+12,ebx          ;      and branch to use
        jmp     Noramp                  ;      non-trapeoidal mode.
                                        ;
Doramp: sar     eax,1                   ; Devide by 2
        sub     eax,4d                  ; Limit = ( Number of steps/2) -1
        mov     cs:[di]+88,eax          ;        Save it
        mov     cs:[di]+84,DWORD PTR 1  ; Set trapezoidal mode flag.
        sub     ebx,ebx                 ; clear ebx (d5)
        sub     esi,esi                 ; clear esi (d7)
        mov     ecx,cs:[di]+80          ; Get rampstep value -> ecx (d6)
        mov     edx,cs:[di]+12          ; Get velocity value -> edx (d2)
        mov     eax,cs:[di]+76          ; Copy Vlimit -> eax (d0) and save
        mov     cs:[di]+48,eax          ;  for ramp-startup-time at offset 48
Rcalc:  sub     eax,ecx                 ; Speed = Speed - Rampstep
        add     esi,1d                  ; Increment ramp counter
        add     ebx,esi                 ;  and calculate #step for ramp. 
        cmp     ebx,cs:[di]+88          ; Counter > Limit ?
        jg      Coisgr                  ; Trap. mode to req. speed Not poss.
        cmp     edx,eax                 ; Current speed < speed ?
        jg      Cuislt                  ; Normal exit condition
        jmp     Rcalc                   ; ..loop..
                                        ;
Coisgr: sub     ebx,esi                 ; Setup counter-values to proper
        sub     esi,1d                  ;  state for ramp-UP & Down time.
        add     eax,ecx                 ; Calculate and update maximum
        mov     cs:[di]+12,eax          ;  possible speed for main-loop.
                                        ;
Cuislt: mov     cs:[di]+92,esi          ; Save Step# for trapezodial UP/DOWN.
        sal     ebx,1                   ; Get Summ of ALL RAMP - Steps.
        sub     cs:[di]+24,ebx          ;     for operating at nontrap. Time.
        mov     ebx,cs:[di]+92          ; SET acceleration count -> ebx (d2)
        mov     cs:[di]+96,DWORD PTR 1  ; Clear = Preset 
                                        ;
Ra_up:  mov     esi,cs:[di]+96          ; Update (d7)
up_mu:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec1                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt.
        dec     esi                     ; Decrement ..
        jnz     up_mu                   ;    ..multiple loop
        add     cs:[di]+96,DWORD PTR 1  ; Update.
        sub     cs:[di]+48,ecx          ; Calculate next trappezodial stepp
        dec     ebx                     ; Loop,
        jnz     Ra_up                   ;      until accelaration is finish.
        ;===============================;
Mlpre:  mov     ebx,cs:[di]+12          ; Get requested speed value and save
        mov     cs:[di]+48,ebx          ;  it at current speed value.
        mov     ebx,cs:[di]+24          ; Recall main-loop count.
Mloop:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec2                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt
        dec     ebx                     ; Main-
        jnz     Mloop                   ;      Loop...
        mov     ebx,cs:[di]+84          ; Get Flag : 
        and     ebx,ebx                 ;       If NOT trapezodial mode
        jz      abo                     ;         Than exit !
        ;===============================;
        mov     ebx,cs:[di]+92          ; Set trapezodial decelaration count.
        sub     cs:[di]+96,DWORD PTR 1  ; Preset , = -1
R_down: mov     esi,cs:[di]+96          ; Update
do_mu:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec3                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt.
        dec     esi                     ; Decrement ..
        jnz     do_mu                   ;    .. multiple loop
        sub     cs:[di]+96,DWORD PTR 1  ; Update
        add     cs:[di]+48,ecx          ; Calculate next decelaration step
        dec     ebx                     ; Loop,
        jnz     R_down                  ;      until decelaration is finish
        ;
        ;
abo:    pop     sp                      ; Restore sp - register
        pop     si                      ; Restore si - register
        pop     di                      ; Restore di - register
        ret
        ;
rec1:   call genrec                     ; RESET
        mov     ebx,cs:[di]+92          ; 
        mov     cs:[di]+96,DWORD PTR 1  ; Clear = Preset
Ruprec: mov     esi,cs:[di]+96          ; Set loop count
upremu: cmp     cs:[di]+116,esi         ; Match #1 ?
        jnz     reupco                  ; NO
        cmp     cs:[di]+112,ebx         ; Match #2 ?
        jz      setdon
reupco: call    SSrec
        dec     esi
        jnz     upremu
        add     cs:[di]+96,DWORD PTR 1  ; Update
        dec     ebx
        jnz     Ruprec
        jmp     setdon
        ;
        ;
rec2:   call    genrec                  ; RESET
        mov     ebx,cs:[di]+84          ; Get Flag : 
        and     ebx,ebx                 ;       If NOT trapezodial mode
        jz      recmon                  ;   Than only main-loop.
        call    rupful
recmon: mov     ebx,cs:[di]+24          ; Recall main loop count.
recmlo: cmp     cs:[di]+112,ebx         ; Match ?
        jz      setdon                  ; YES, all done here !
        call    SSrec
        dec     ebx                     ; Decrement
        jnz     recmlo                  ;    and loop utill..
        jmp     setdon                  ;  
        ;
        ;
rec3:   call    genrec                  ; RESET
        call    rupful
                                        ;
        mov     ebx,cs:[di]+24          ; Recall main loop count ->ebx
rec31:  call    SSrec
        dec     ebx                     ; Decrement and
        jnz     rec31                   ;   loop main part.
                                        ;
        mov     ebx,cs:[di]+92          ; 
        sub     cs:[di]+96,DWORD PTR 1  ; Preset ( = -1 )
Rdorec: mov     esi,cs:[di]+96          ; Set
doremu: cmp     cs:[di]+116,esi         ; Match #1 ?
        jnz     rdopco                  ; NO
        cmp     cs:[di]+112,ebx         ; Match #2 ?
        jz      setdon
rdopco: call    SSrec
        dec     esi
        jnz     doremu
        sub     cs:[di]+96,DWORD PTR 1  ; Update
        dec     ebx
        jnz     Rdorec
        ;
        ;
setdon: mov     cs:[di]+120,DWORD PTR 1 ; ** SET EMERG. ABORT FLAG ** 
        jmp     abo
        ;
stepp   endp
        ;    
        ;
        ;       Recover routine for a full RAMP-UP section
rupful  proc
        mov     cs:[di]+96,DWORD PTR 1  ; Clear = Preset 
        mov     ebx,cs:[di]+92          ; Get Nr. of steps
rupfu1: mov     esi,cs:[di]+96          ; Set loop count
rupfu2: call SSrec
        dec     esi
        jnz     rupfu2
        add     cs:[di]+96,DWORD PTR 1  ; Update
        dec     ebx
        jnz      rupfu1
        ret
rupful  endp
        ;    
        ;
        ;      $$ Stepping position recover routine
SSrec   proc
        mov     al,cs:[di]+16           ; Get Direction info
        mov     edx,cs:[di]+36          ; Main-Axis ->edx
        and     edx,00000001H           ; X-Axis = Main-Axis ?
        jz      xnom                    ; NO !
        and     al,00001000b            ;- Mask X-DIrection, Positiv ?
        jnz     xmwpo                   ;- YES
        sub     cs:[di],DWORD PTR 1     ; Decrement X-Position (main) 
        jmp     mdone
xmwpo:  add     cs:[di],DWORD PTR 1     ; Increment X-Position (main)
        jmp     mdone
xnom:   mov     edx,cs:[di]+36          ; Main-Axis ->edx
        and     edx,00000002H           ; Y-Axis = Main-Axis ?
        jz      ynom
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     ymwpo                   ;- YES
        sub     cs:[di]+4,DWORD PTR 1   ; Decrement Y-Position (main)
        jmp     mdone
ymwpo:  add     cs:[di]+4,DWORD PTR 1   ; Increment Y-Position (main)
        jmp     mdone
ynom:   mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     zmwpo                   ;- YES
        sub     cs:[di]+8,DWORD PTR 1   ; Decrement Z-Position (main)
        jmp     mdone
zmwpo:  add     cs:[di]+8,DWORD PTR 1   ; Increment Z-Position (main)
                                        ;
mdone:  mov     edx,cs:[di]+52      ; Recall "err_1" =>edx
        and     edx,edx             ; Test edx,=err_1
        jg      Egtre1              ; Branch if "err-1" > 0
        mov     edx,cs:[di]+56      ; Recall "kerr_1"
        add     cs:[di]+52,edx      ; "err_1" = "err_1" + "kerr_1"
        jmp     A2Chek
Egtre1: mov     edx,cs:[di]+40          ; 1st Axis ->edx
        and     edx,00000001H           ; X-Axis = 1st-Axis ?
        jz      Xno1st                  ; NO !
        mov     al,cs:[di]+16           ; Get Direction info -
        and     al,00001000b            ;- Mask X-Direction, Positiv ?
        jnz     X1wpo                   ;- YES !
        sub     cs:[di],DWORD PTR 1     ; Decrement X-Position (1st) 
        jmp     Upd1st
x1wpo:  add     cs:[di],DWORD PTR 1     ; Increment X-Position (1st)
        jmp     Upd1st
Xno1st: mov     edx,cs:[di]+40          ; 1st-Axis ->edx
        and     edx,00000002H           ; Y-Axis = 1st-Axis ?
        jz      Yno1st                  ; NO!
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     Y1wpo                   ;- YES
        sub     cs:[di]+4,DWORD PTR 1   ; Decrement Y-Position (1st)
        jmp     Upd1st
Y1wpo:  add     cs:[di]+4,DWORD PTR 1   ; Increment Y-Position (1st)
        jmp     Upd1st 
Yno1st: mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     z1wpo                   ;- YES
        sub     cs:[di]+8,DWORD PTR 1   ; Decrement Z-Position (1st)
        jmp     Upd1st
z1wpo:  add     cs:[di]+8,DWORD PTR 1   ; Increment Z-Position (1st)
Upd1st: mov     edx,cs:[di]+60      ; Recall "gerr_1"
        add     cs:[di]+52,edx      ; "err_1" = "err_1" + "gerr_1"
A2Chek: mov     edx,cs:[di]+64      ; Recall "err_2" =>edx
        and     edx,edx             ; Test edx,=err_2
        jg      Egtre2              ; Branch if "err_2" > 0
        mov     edx, cs:[di]+68     ; Recall "kerr_2"
        add     cs:[di]+64,edx      ; "err_2" = "err_2" + "kerr_2"
        jmp     Recdon 
Egtre2: mov     edx,cs:[di]+44          ; 2nd Axis ->edx
        and     edx,00000001H           ; X-Axis = 2nd-Axis ?
        jz      Xno2nd                  ; NO !
        mov     al,cs:[di]+16           ; Get Direction info -
        and     al,00001000b            ;- Mask X-Direction, Positiv ?
        jnz     X2wpo                   ;- YES !
        sub     cs:[di],DWORD PTR 1     ; Decrement X-Position (2nd) 
        jmp     Upd2nd
x2wpo:  add     cs:[di],DWORD PTR 1     ; Increment X-Position (2nd)
        jmp     Upd2nd
Xno2nd: mov     edx,cs:[di]+44          ; 2nd-Axis ->edx
        and     edx,00000002H           ; Y-Axis = 2nd-Axis ?
        jz      Yno2nd                  ; NO!
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     Y2wpo                   ;- YES
        sub     cs:[di]+4,DWORD PTR 1   ; Decrement Y-Position (2nd)
        jmp     Upd2nd
Y2wpo:  add     cs:[di]+4,DWORD PTR 1   ; Increment Y-Position (2nd)
        jmp     Upd2nd 
Yno2nd: mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     z2wpo                   ;- YES
        sub     cs:[di]+8,DWORD PTR 1   ; Decrement Z-Position (2nd)
        jmp     Upd2nd
z2wpo:  add     cs:[di]+8,DWORD PTR 1   ; Increment Z-Position (2nd)
Upd2nd: mov     edx,cs:[di]+72   ; Recall "gerr_2"
        add     cs:[di]+64,edx   ; "err_2" = "err_2" + "gerr_2"
Recdon: ret
SSrec   endp
        ;
        ;       Reset X/Y/Z counter to start-entry values
genrec  proc
        mov     cs:[di]+112,ebx         ; Save ebx (d2)
        mov     cs:[di]+116,esi         ; Save esi (d7)
        mov     al,cs:[di]+16           ; Get Direction info 
        mov     ebx,cs:[di]+100         ; Get ABS(x-Stepp) ->ebx
        and     al,00001000b            ; Mask X-Direction
        jz      Xne                     ; 
        sub     cs:[di],ebx             ; X-RESET, if xstepp were pos.
        jmp     Yr
Xne:    add     cs:[di],ebx             ; X-RESET, if xstepp were neg.
Yr:     mov     al,cs:[di]+16           ; Get Direction info 
        mov     ebx,cs:[di]+104         ; Get ABS(y-Stepp) ->ebx
        and     al,00010000b            ; Mask out
        jz      Yne
        sub     cs:[di]+4,ebx           ; Y-RESET, if ystepp were pos
        jmp     Zr
Yne:    add     cs:[di]+4,ebx           ; Y-RESET, if ystepp were neg.
Zr:     mov     al,cs:[di]+16           ; Get Direction info 
        mov     ebx,cs:[di]+108         ; Get ABS(z-Stepp) ->ebx
        and     al,00100000b            ; Mask aut
        jz      Zne
        sub     cs:[di]+8,ebx           ; Z-RESET, if ystepp were pos
        jmp     RECex
Zne:    add     cs:[di]+8,ebx           ; Z-RESET, if ystepp were neg.
RECex:  ret
genrec  endp
        ;
        ; Stepping - Subroutine. Use Bresenham's Algorith to
        ; execute single or multiple axis movement for one stepp.
        ;
sistepp proc
        mov     al,cs:[di]+16    ; RESTORE al-register
        or      al,cs:[di]+36    ; ENABLE exis_m
        ;
        mov     edx,cs:[di]+52   ; Recall "err_1" =>edx
        and     edx,edx          ; Test edx,=err_1
        jg      Egt_1            ; Branch if "err-1" > 0
        mov     edx,cs:[di]+56   ; Recall "kerr_1"
        add     cs:[di]+52,edx   ; "err_1" = "err_1" + "kerr_1"
        jmp     Che2nd           ; DISABLE axis_1 & jump
Egt_1:  or      al,cs:[di]+40    ; ENABLE  axis_1
        mov     edx,cs:[di]+60   ; Recall "gerr_1"
        add     cs:[di]+52,edx   ; "err_1" = "err_1" + "gerr_1"
        ;
Che2nd: mov     edx,cs:[di]+64   ; Recall "err_2" =>edx
        and     edx,edx          ; Test edx,=err_2
        jg      Egt_2            ; Branch if "err_2" > 0
        mov     edx, cs:[di]+68  ; Recall "kerr_2"
        add     cs:[di]+64,edx   ; "err_2" = "err_2" + "kerr_2"
        jmp     Dostep           ; DISABLE axis_2 & jump
Egt_2:  or      al,cs:[di]+44    ; ENABLE  axis_2
        mov     edx,cs:[di]+72   ; Recall "gerr_2"
        add     cs:[di]+64,edx   ; "err_2" = "err_2" + "gerr_2"
Dostep: mov     cs:[di]+20,al    ; SAVE al - Register
        ; -----------------------
        mov     dx,378H         ; Base-Address
        mov     al,cs:[di]+16   ; DATA - LOW level
        out     dx,al           ; Set ALL =Output=0
        inc     dx              ; POINT to controll-register
        inc     dx              ;   "    "    "        "
        mov     al,1            ; AL <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW 
        dec     dx              ; Point to Base
        dec     dx              ;   "    "   "
        mov     al,cs:[di]+20   ; set DATA - HIGH level
        out     dx,al           ; Set ALL =Output=1
        inc     dx              ; POINT to controll-register
        inc     dx              ;  "     "    "        "
        mov     al,1            ; AL <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW
        ; ----------------------- 
        ; Delay:
        mov     edx,cs:[di]+48
nl:     nop
        dec     edx
        jnz     nl
        ret                     ; Return from Single-Step.
        ; 
        ;
gab     db   2 dup(3)
lobuf   db 120 dup(0)
endb1   dd   1 dup(12345678h)
        ;
sistepp endp
        ;
        ;
        end
