        ; ***************************************************************
        ; *** 3D-Stepping Procedure - For Intel 8088  (c) R.Heuberger ***
        ; ***************************************************************
        ; ***        Verison fr SHARP & SHD-Adapter-BOX              ***
        ; ***************************************************************
        ;      Mit Stop & Recover-Stepp-Routinen, fertig 16-MAR-93
        ; 
        ;       Eingangs-Bedingungen:  X-Schritte: AX
        ;                              Y-Schritte: BX
        ;                              Z-Schritte: CX
        ;                Vorschub-Geschwindigkeit: DX
        ;
        ; Defenitions - local buffer ( offsets ) :  
        ;  di[0]  = PHYSICAL-xstepp      di[4]  = PHYSICAL-ystepp 
        ;  di[8]  = PHYSICAL-zstepp      di[12] = Backup cx
        ;  di[16] = Backup al            di[20] = Backup al
        ;  di[24] = step_M               di[28] = step_1
        ;  di[32] = step_2               di[36] = Stepword, step_M
        ;  di[40] = Stepword, step_1     di[44] = Stepword, step_2
        ;  di[48] = Temp & Main-Speed    di[52] = err_1
        ;  di[56] = kerr_1               di[60] = gerr_1
        ;  di[64] = err_2                di[68] = kerr_2
        ;  di[72] = gerr_2               
        ;  di[76] = Limit switching to trapezoidal mode ( mac_a% )
        ;  di[80] = Trapezoidal step value ( mac_b% )
        ;  di[84] = FLAG, 1=Use trapezoidal mode.  
        ;  di[88] = Will contain calulated Limit.         
        ;  di[92] = Calculated number of necessary steps. 
        ;  di[96] = Loop-Count.
        ;  di[100] = ax - SAVE
        ;  di[104] = bx - SAVE
        ;  di[108] = cx - SAVE
        ;  di[112] = Storage & Save for bx ( d2 ) , emercency STOP !
        ;  di[116] = Storage & Save for si ( d7 ) , emercency STOP !
        ;
        ;
        TITLE 8255
        .Model Large
        .8086
        .code
        ;
stepp   proc
        push    di              ; Save di
        push    si              ; Save si
        ;push    sp              ; Save sp
        ;
        ;mov     ax,4000d       ; $- DEBUG purpose, xstepp% -$
        ;mov     bx,2000d       ; $- DEBUG purpose, ystepp% -$
        ;mov     cx,1000d       ; $- DEBUG purpose, zstepp% -$
        ;mov     dx,1600d       ; $- DEBUG purpose, speed%  -$
        ;
        and     ax,ax           ; IF   xstepp value not equal "0"
        jne     sbegin          ; THEN start program.
        and     bx,bx           ; IF   ystepp value not equal "0"
        jne     sbegin          ; THEN start program.
        and     cx,cx           ; IF   zstepp value equal "0"
        je      abo             ; THEN exit.
        ;
sbegin: lea     di, OFFSET lobuf   ; di = Pointer to local buffer.
        mov     cs:[di]+104,bx     ; Save bx-Register
        mov     cs:[di]+108,cx     ; Save cx-Register
        mov     cs:[di]+12,dx      ; Save speed value local ( 16 bit ).
        ;
        ;mov     cs:[di]+76,WORD PTR 3000d    ; $- DEBUG > A-PARAM -$
        ;mov     cs:[di]+80,WORD PTR 15       ; $- DEBUG > B-PARAM -$
        ;
        add     cs:[di],ax        ;-; PHYSICAL: Calculate current X-Position.
        add     cs:[di]+4,bx      ;-; PHYSICAL: Calculate current Y-Position.
        add     cs:[di]+8,cx      ;-; PHYSICAL: Calculate current Z-Position.
        ;
        and     ax,ax           ; Test, = Find X-direction.
        js      Xtopos          ;  X-DIR = backwards.
        mov     cs:[di]+100,ax  ; SAVE ax-Register !
        mov     al,00001000b    ; Set X - forward bit
        jmp     Chey            ; 
Xtopos: neg     ax              ; Make X-Step posetive !
        mov     cs:[di]+100,ax  ; SAVE ax-Register !
        mov     al,00000000b    ; Clear - al, = X Backwards.
Chey:   and     bx,bx           ; Test, = Find Y-diriction.
        js      Ytopos          ; Y-DIR  already done.
        or      al,00010000b    ; SET Y - forward bit.
        jmp     Chez
Ytopos: neg     bx              ; Make Y - Step posetive !
        mov     cs:[di]+104,bx  ; SAVE bx-Register AGAIN!
Chez:   and     cx,cx           ; Test, = Find Z-direktion.
        js      Ztopos          ; Z-DIR already done.
        or      al,00100000b    ; Set Z - forward bit.
        jmp     Sdir            ; 
Ztopos: neg     cx              ; Make Z - Step posetive !
        mov     cs:[di]+108,cx  ; SAVE cx-Register AGAIN!
        ;
Sdir:   mov     cs:[di]+16,al   ; Save al - Register
        mov     cs:[di]+20,al   ; Save al - Register 
        mov     dx,378H         ; Base-Address
        out     dx,al           ; Set CSR-Output-register = Axis directions.
        inc     dx              ; POINT to CSR - controll-register
        inc     dx              ;   "    "    "        "
        mov     al,1            ; al <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW
        ; 
        ;   - Find axis_M, = axis with greatest movement.
        ;   - Check & order deltas, axis_M, axis_1, axis_2.
        ;
        mov     ax,cs:[di]+100       ; RESTORE ax - register  
        cmp     bx,ax                ; Compare Xstepp with Ystepp.
        jg      YgtX                 ; Ystepp > Xstepp
XgtY:   cmp     cx,ax                ; Compare Xstepp with Zstepp.
        jg      ZgtXY                ; Zstepp > Xstepp
        mov     cs:[di]+24,ax        ;-> X-axis has greatest movement! 
        mov     cs:[di]+28,bx        ;\
        mov     cs:[di]+32,cx        ;\\      
        mov     al,00000001b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if X-axis
        mov     al,00000010b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000100b         ;//
        mov     cs:[di]+44,al        ;/
        jmp     Cabre                ;
YgtX:   cmp     cx,bx                ; Compare Ystepp with Zstepp
        jg      ZgtXY                ; Zstepp > Ystepp
        mov     cs:[di]+24,bx        ;-> Y-axis has greatest movement!
        mov     cs:[di]+28,ax        ;\
        mov     cs:[di]+32,cx        ;\\       
        mov     al,00000010b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if Y-axis
        mov     al,00000001b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000100b         ;//
        mov     cs:[di]+44,al        ;/
        jmp     Cabre                ;
ZgtXY:  mov     cs:[di]+24,cx        ;-> Z-axis has greatest movement!
        mov     cs:[di]+28,ax        ;\
        mov     cs:[di]+32,bx        ;\\       
        mov     al,00000100b         ;\\\
        mov     cs:[di]+36,al        ;>>>> Setup sequenze if Z-axis
        mov     al,00000001b         ;>>>>      is Main-Axis.
        mov     cs:[di]+40,al        ;///
        mov     al,00000010b         ;//
        mov     cs:[di]+44,al        ;/
        ;
        ;
        ;  ***  Calculate values for Bresenham's Algorithm. ***
        ;        Note: ax-register already saved.. index 0
        ;
Cabre:  mov     ax,cs:[di]+24           ; Get delta_M      =>ax
        mov     bx,cs:[di]+28           ; Get delta_1      =>bx
        mov     cx,cs:[di]+24           ; Backup  delta_M  =>cx
        sal     bx,1                    ; delta_1 = delta_1 * 2
        sal     ax,1                    ; delta_M = delta_M * 2
        mov     cs:[di]+56,bx           ; SAVE "kerr_1",( prepare,if err_1>0 )
        mov     cs:[di]+48,bx           ; Backup delta_1 => "temp1" 
        sub     bx,cx                   ; err_1 = 2*delta_1-delta_M
        mov     cs:[di]+52,bx           ; SAVE err_1
        mov     bx,cs:[di]+48           ; RECALL delta_1 temp1 =>bx
        sub     bx,ax                   ; "gerr_1" = 2*delta_1 - 2*delta_M
        mov     cs:[di]+60,bx           ; SAVE "gerr_1"
        ; ------------------------------;
        mov     ax,cs:[di]+24           ; Get delta_M      =>ax
        mov     bx,cs:[di]+32           ; Get delta_2      =>bx
        mov     cx,cs:[di]+24           ; Backup  delta_M  =>cx
        sal     bx,1                    ; delta_2 = delta_2 * 2
        sal     ax,1                    ; delta_M = delta_M * 2
        mov     cs:[di]+68,bx           ; SAVE "kerr_2",( prepare,if err_1>0 )
        mov     cs:[di]+48,bx           ; Backup delta_2 => "temp1" 
        sub     bx,cx                   ; "err_2" = 2*delta_2-delta_M
        mov     cs:[di]+64,bx           ; SAVE "err_2"
        mov     bx,cs:[di]+48           ; RECALL delta_2 temp1 =>bx
        sub     bx,ax                   ; "gerr_2" = 2*delta_2 - 2*delta_M
        mov     cs:[di]+72,bx           ; SAVE "gerr_2"
        ;
        ;
        ;     Check and decide to use trapezoidal velocity mode.
        ;
        mov     bx,cs:[di]+76           ; Get velocity treshold ->ax
        sub     bx,cs:[di]+80           ; Align treshold with mac_b& !
        cmp     bx,cs:[di]+12           ; IF   velocity limit reached.
        jg      Rampe                   ; THEN check to use trapezoidal mode.
Noramp: mov     cs:[di]+84,WORD PTR 0   ;  ELSE clear FLAG,
        jmp     Mlpre                   ;      start non trapezoidal mode.
                                        ;
Rampe:  mov     ax,cs:[di]+24           ; Get number of steps ->ax
        cmp     ax,40d                  ; If   it makes sence using trapezoid.
        jg      Doramp                  ; THEN branch and prepare parameter
        mov     bx,cs:[di]+76           ; ELSE corect velocity value
        mov     cs:[di]+12,bx           ;      and branch to use
        jmp     Noramp                  ;      non-trapeoidal mode.
                                        ;
Doramp: sar     ax,1                    ; Devide by 2
        sub     ax,4d                   ; Limit = ( Number of steps/2) -1
        mov     cs:[di]+88,ax           ;        Save it
        mov     cs:[di]+84,WORD PTR 1   ; Set trapezoidal mode flag.
        sub     bx,bx                   ; clear bx (d5)
        sub     si,si                   ; clear si (d7)
        mov     cx,cs:[di]+80           ; Get rampstep value -> cx (d6)
        mov     dx,cs:[di]+12           ; Get velocity value -> dx (d2)
        mov     ax,cs:[di]+76           ; Copy Vlimit -> ax (d0) and save
        mov     cs:[di]+48,ax           ;  for ramp-startup-time at offset 48
Rcalc:  sub     ax,cx                   ; Speed = Speed - Rampstep
        add     si,1d                   ; Increment ramp counter
        add     bx,si                   ;  and calculate #step for ramp. 
        cmp     bx,cs:[di]+88           ; Counter > Limit ?
        jg      Coisgr                  ; Trap. mode to req. speed Not poss.
        cmp     dx,ax                   ; Current speed < speed ?
        jg      Cuislt                  ; Normal exit condition
        jmp     Rcalc                   ; ..loop..
                                        ;
Coisgr: sub     bx,si                   ; Setup counter-values to proper
        sub     si,1d                   ;  state for ramp-UP & Down time.
        add     ax,cx                   ; Calculate and update maximum
        mov     cs:[di]+12,ax           ;  possible speed for main-loop.
                                        ;
Cuislt: mov     cs:[di]+92,si           ; Save Step# for trapezodial UP/DOWN.
        sal     bx,1                    ; Get Summ of ALL RAMP - Steps.
        sub     cs:[di]+24,bx           ;     for operating at nontrap. Time.
        mov     bx,cs:[di]+92           ; SET acceleration count -> bx (d2)
        mov     cs:[di]+96,WORD PTR 1   ; Clear = Preset 
                                        ;
Ra_up:  mov     si,cs:[di]+96           ; Update (d7)
up_mu:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec1                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt.
        dec     si                      ; Decrement ..
        jnz     up_mu                   ;    ..multiple loop
        add     cs:[di]+96,WORD PTR 1   ; Update.
        sub     cs:[di]+48,cx           ; Calculate next trappezodial stepp
        dec     bx                      ; Loop,
        jnz     Ra_up                   ;      until accelaration is finish.
        ;===============================;
Mlpre:  mov     bx,cs:[di]+12           ; Get requested speed value and save
        mov     cs:[di]+48,bx           ;  it at current speed value.
        mov     bx,cs:[di]+24           ; Recall main-loop count.
Mloop:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec2                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt
        dec     bx                      ; Main-
        jnz     Mloop                   ;      Loop...
        mov     bx,cs:[di]+84           ; Get Flag : 
        and     bx,bx                   ;       If NOT trapezodial mode
        jz      abo                     ;         Than exit !
        ;===============================;
        mov     bx,cs:[di]+92           ; Set trapezodial decelaration count.
        sub     cs:[di]+96,WORD PTR 1   ; Preset , = -1
R_down: mov     si,cs:[di]+96           ; Update
do_mu:  mov     dx,379H                 ;+++>  CSR-Address
        in      al,dx                   ;+++>  Get Printerport-Status
        TEST    al,80H                  ;+++>  Test BUSY - bit
        jz      rec3                    ;+++>  External STOP !
        call    sistepp                 ; Ein 3D-Schritt.
        dec     si                      ; Decrement ..
        jnz     do_mu                   ;    .. multiple loop
        sub     cs:[di]+96,WORD PTR 1   ; Update
        add     cs:[di]+48,cx           ; Calculate next decelaration step
        dec     bx                      ; Loop,
        jnz     R_down                  ;      until decelaration is finish
        ;
        ;
abo:    ;pop     sp                      ; Restore sp - register
        pop     si                      ; Restore si - register
        pop     di                      ; Restore di - register
        ret
        ;
rec1:   call genrec                     ; RESET
        mov     bx,cs:[di]+92           ; 
        mov     cs:[di]+96,WORD PTR 1   ; Clear = Preset
Ruprec: mov     si,cs:[di]+96           ; Set loop count
upremu: cmp     cs:[di]+116,si          ; Match #1 ?
        jnz     reupco                  ; NO
        cmp     cs:[di]+112,bx          ; Match #2 ?
        jz      setdon
reupco: call    SSrec
        dec     si
        jnz     upremu
        add     cs:[di]+96,WORD PTR 1   ; Update
        dec     bx
        jnz     Ruprec
        jmp     setdon
        ;
        ;
rec2:   call    genrec                  ; RESET
        mov     bx,cs:[di]+84           ; Get Flag : 
        and     bx,bx                   ;       If NOT trapezodial mode
        jz      recmon                  ;   Than only main-loop.
        call    rupful
recmon: mov     bx,cs:[di]+24           ; Recall main loop count.
recmlo: cmp     cs:[di]+112,bx          ; Match ?
        jz      setdon                  ; YES, all done here !
        call    SSrec
        dec     bx                      ; Decrement
        jnz     recmlo                  ;    and loop utill..
        jmp     setdon                  ;  
        ;
        ;
rec3:   call    genrec                  ; RESET
        call    rupful
                                        ;
        mov     bx,cs:[di]+24           ; Recall main loop count ->bx
rec31:  call    SSrec
        dec     bx                      ; Decrement and
        jnz     rec31                   ;   loop main part.
                                        ;
        mov     bx,cs:[di]+92           ; 
        sub     cs:[di]+96,WORD PTR 1   ; Preset ( = -1 )
Rdorec: mov     si,cs:[di]+96           ; Set
doremu: cmp     cs:[di]+116,si          ; Match #1 ?
        jnz     rdopco                  ; NO
        cmp     cs:[di]+112,bx          ; Match #2 ?
        jz      setdon
rdopco: call    SSrec
        dec     si
        jnz     doremu
        sub     cs:[di]+96,WORD PTR 1   ; Update
        dec     bx
        jnz     Rdorec
        ;
        ;
setdon: mov     cs:[di]+120,WORD PTR 1  ; ** SET EMERG. ABORT FLAG ** 
        jmp     abo
        ;
stepp   endp
        ;    
        ;
        ;       Recover routine for a full RAMP-UP section
rupful  proc
        mov     cs:[di]+96,WORD PTR 1   ; Clear = Preset 
        mov     bx,cs:[di]+92           ; Get Nr. of steps
rupfu1: mov     si,cs:[di]+96           ; Set loop count
rupfu2: call SSrec
        dec     si
        jnz     rupfu2
        add     cs:[di]+96,WORD PTR 1   ; Update
        dec     bx
        jnz      rupfu1
        ret
rupful  endp
        ;    
        ;
        ;      $$ Stepping position recover routine
SSrec   proc
        mov     al,cs:[di]+16           ; Get Direction info
        mov     dx,cs:[di]+36           ; Main-Axis ->dx
        and     dx,0001H                ; X-Axis = Main-Axis ?
        jz      xnom                    ; NO !
        and     al,00001000b            ;- Mask X-DIrection, Positiv ?
        jnz     xmwpo                   ;- YES
        sub     cs:[di],WORD PTR 1      ; Decrement X-Position (main) 
        jmp     mdone
xmwpo:  add     cs:[di],WORD PTR 1      ; Increment X-Position (main)
        jmp     mdone
xnom:   mov     dx,cs:[di]+36           ; Main-Axis ->dx
        and     dx,0002H                ; Y-Axis = Main-Axis ?
        jz      ynom
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     ymwpo                   ;- YES
        sub     cs:[di]+4,WORD PTR 1    ; Decrement Y-Position (main)
        jmp     mdone
ymwpo:  add     cs:[di]+4,WORD PTR 1    ; Increment Y-Position (main)
        jmp     mdone
ynom:   mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     zmwpo                   ;- YES
        sub     cs:[di]+8,WORD PTR 1    ; Decrement Z-Position (main)
        jmp     mdone
zmwpo:  add     cs:[di]+8,WORD PTR 1    ; Increment Z-Position (main)
                                        ;
mdone:  mov     dx,cs:[di]+52       ; Recall "err_1" =>dx
        and     dx,dx               ; Test  dx,=err_1
        jg      Egtre1              ; Branch if "err-1" > 0
        mov     dx,cs:[di]+56       ; Recall "kerr_1"
        add     cs:[di]+52,dx       ; "err_1" = "err_1" + "kerr_1"
        jmp     A2Chek
Egtre1: mov     dx,cs:[di]+40           ; 1st Axis ->dx
        and     dx,0001H                ; X-Axis = 1st-Axis ?
        jz      Xno1st                  ; NO !
        mov     al,cs:[di]+16           ; Get Direction info -
        and     al,00001000b            ;- Mask X-Direction, Positiv ?
        jnz     X1wpo                   ;- YES !
        sub     cs:[di],WORD PTR 1      ; Decrement X-Position (1st) 
        jmp     Upd1st
x1wpo:  add     cs:[di],WORD PTR 1      ; Increment X-Position (1st)
        jmp     Upd1st
Xno1st: mov     dx,cs:[di]+40           ; 1st-Axis ->dx
        and     dx,0002H                ; Y-Axis = 1st-Axis ?
        jz      Yno1st                  ; NO!
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     Y1wpo                   ;- YES
        sub     cs:[di]+4,WORD PTR 1    ; Decrement Y-Position (1st)
        jmp     Upd1st
Y1wpo:  add     cs:[di]+4,WORD PTR 1    ; Increment Y-Position (1st)
        jmp     Upd1st 
Yno1st: mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     z1wpo                   ;- YES
        sub     cs:[di]+8,WORD PTR 1    ; Decrement Z-Position (1st)
        jmp     Upd1st
z1wpo:  add     cs:[di]+8,WORD PTR 1    ; Increment Z-Position (1st)
Upd1st: mov     dx,cs:[di]+60       ; Recall "gerr_1"
        add     cs:[di]+52,dx       ; "err_1" = "err_1" + "gerr_1"
A2Chek: mov     dx,cs:[di]+64       ; Recall "err_2" =>dx
        and     dx,dx               ; Test dx,=err_2
        jg      Egtre2              ; Branch if "err_2" > 0
        mov     dx, cs:[di]+68      ; Recall "kerr_2"
        add     cs:[di]+64,dx       ; "err_2" = "err_2" + "kerr_2"
        jmp     Recdon 
Egtre2: mov     dx,cs:[di]+44           ; 2nd Axis -> dx
        and     dx,0001H                ; X-Axis = 2nd-Axis ?
        jz      Xno2nd                  ; NO !
        mov     al,cs:[di]+16           ; Get Direction info -
        and     al,00001000b            ;- Mask X-Direction, Positiv ?
        jnz     X2wpo                   ;- YES !
        sub     cs:[di],WORD PTR 1      ; Decrement X-Position (2nd) 
        jmp     Upd2nd
x2wpo:  add     cs:[di],WORD PTR 1      ; Increment X-Position (2nd)
        jmp     Upd2nd
Xno2nd: mov     dx,cs:[di]+44           ; 2nd-Axis ->dx
        and     dx,0002H                ; Y-Axis = 2nd-Axis ?
        jz      Yno2nd                  ; NO!
        mov     al,cs:[di]+16           ; Get Direction info
        and     al,00010000b            ;- Mask Y-Direction, Positiv ?
        jnz     Y2wpo                   ;- YES
        sub     cs:[di]+4,WORD PTR 1    ; Decrement Y-Position (2nd)
        jmp     Upd2nd
Y2wpo:  add     cs:[di]+4,WORD PTR 1    ; Increment Y-Position (2nd)
        jmp     Upd2nd 
Yno2nd: mov     al,cs:[di]+16           ; Get Direction info
        and     al,00100000b            ;- Mask Z-direction, Positiv ?
        jnz     z2wpo                   ;- YES
        sub     cs:[di]+8,WORD PTR 1    ; Decrement Z-Position (2nd)
        jmp     Upd2nd
z2wpo:  add     cs:[di]+8,WORD PTR 1    ; Increment Z-Position (2nd)
Upd2nd: mov     dx,cs:[di]+72           ; Recall "gerr_2"
        add     cs:[di]+64,dx           ; "err_2" = "err_2" + "gerr_2"
Recdon: ret
SSrec   endp
        ;
        ;       Reset X/Y/Z counter to start-entry values
genrec  proc
        mov     cs:[di]+112,bx          ; Save bx (d2)
        mov     cs:[di]+116,si          ; Save si (d7)
        mov     al,cs:[di]+16           ; Get Direction info 
        mov     bx,cs:[di]+100          ; Get ABS(x-Stepp) ->bx
        and     al,00001000b            ; Mask X-Direction
        jz      Xne                     ; 
        sub     cs:[di],bx              ; X-RESET, if xstepp were pos.
        jmp     Yr
Xne:    add     cs:[di],bx              ; X-RESET, if xstepp were neg.
Yr:     mov     al,cs:[di]+16           ; Get Direction info 
        mov     bx,cs:[di]+104          ; Get ABS(y-Stepp) ->bx
        and     al,00010000b            ; Mask out
        jz      Yne
        sub     cs:[di]+4,bx            ; Y-RESET, if ystepp were pos
        jmp     Zr
Yne:    add     cs:[di]+4,bx            ; Y-RESET, if ystepp were neg.
Zr:     mov     al,cs:[di]+16           ; Get Direction info 
        mov     bx,cs:[di]+108          ; Get ABS(z-Stepp) ->bx
        and     al,00100000b            ; Mask aut
        jz      Zne
        sub     cs:[di]+8,bx            ; Z-RESET, if ystepp were pos
        jmp     RECex
Zne:    add     cs:[di]+8,bx            ; Z-RESET, if ystepp were neg.
RECex:  ret
genrec  endp
        ;
        ; Stepping - Subroutine. Use Bresenham's Algorith to
        ; execute single or multiple axis movement for one stepp.
        ;
sistepp proc
        mov     al,cs:[di]+16    ; RESTORE al-register
        or      al,cs:[di]+36    ; ENABLE exis_m
        ;
        mov     dx,cs:[di]+52    ; Recall "err_1" =>dx
        and     dx,dx            ; Test dx,=err_1
        jg      Egt_1            ; Branch if "err-1" > 0
        mov     dx,cs:[di]+56    ; Recall "kerr_1"
        add     cs:[di]+52,dx    ; "err_1" = "err_1" + "kerr_1"
        jmp     Che2nd           ; DISABLE axis_1 & jump
Egt_1:  or      al,cs:[di]+40    ; ENABLE  axis_1
        mov     dx,cs:[di]+60    ; Recall "gerr_1"
        add     cs:[di]+52,dx    ; "err_1" = "err_1" + "gerr_1"
        ;
Che2nd: mov     dx,cs:[di]+64    ; Recall "err_2" =>dx
        and     dx,dx            ; Test dx,=err_2
        jg      Egt_2            ; Branch if "err_2" > 0
        mov     dx, cs:[di]+68   ; Recall "kerr_2"
        add     cs:[di]+64,dx    ; "err_2" = "err_2" + "kerr_2"
        jmp     Dostep           ; DISABLE axis_2 & jump
Egt_2:  or      al,cs:[di]+44    ; ENABLE  axis_2
        mov     dx,cs:[di]+72    ; Recall "gerr_2"
        add     cs:[di]+64,dx    ; "err_2" = "err_2" + "gerr_2"
Dostep: mov     cs:[di]+20,al    ; SAVE al - Register
        ; -----------------------
        mov     dx,378H         ; Base-Address
        mov     al,cs:[di]+16   ; DATA - LOW level
        out     dx,al           ; Set ALL =Output=0
        inc     dx              ; POINT to controll-register
        inc     dx              ;   "    "    "        "
        mov     al,1            ; AL <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW 
        dec     dx              ; Point to Base
        dec     dx              ;   "    "   "
        mov     al,cs:[di]+20   ; set DATA - HIGH level
        out     dx,al           ; Set ALL =Output=1
        inc     dx              ; POINT to controll-register
        inc     dx              ;  "     "    "        "
        mov     al,1            ; AL <--"1"
        out     dx,al           ; Strobe = HIGH
        dec     al              ; All <--"0"
        out     dx,al           ; Strobe = LOW
        ; ----------------------- 
        ; Delay:
        mov     dx,cs:[di]+48
nl:     nop
        dec     dx
        jnz     nl
        ret                     ; Return from Single-Step.
        ; 
        ;
gab     db   2 dup(3)
lobuf   db 120 dup(0)
endb1   dd   1 dup(12345678h)
        ;
sistepp endp
        ;
        ;
        end
