        ;      ***************************************
        ;      ***  Kuehlmittel & Spindel-Antrieb  ***
        ;      *****  Interrupt enable & disable  ****
        ;      ***************************************
        ;      ********  8255 based Version  *********
        ;      ***************************************
        ;
        ; Eingangbedingungen von EBX:  0 = Keine Aktion (init)
        ;                              1 = Spindelantrieb - RECHTS AN
        ;                              2 = Spindelantrieb - RECHTS AUS
        ;                              3 = Spindelantrieb - LINKS AN
        ;                              4 = Spindelantrieb - LINKS AUS
        ;                              5 = Kuehlmittelantrieb AN
        ;                              6 = Kuehlmittelantrieb AUS
        ;                              7 = Interrupts OFF
        ;                              8 = Interrupts ON
        ;
        ;  Assembler-Rountine zur Ansteuerung des Khlmittel und
        ;  Spindel-Antrieb fr 8255 based AT-Bus Interface.
        ;
        ; Fertigstellung am Freitag den 2-APR-1993. ( Vor Ostern )
        ; Situation: Nicht mehr auszuhalten... "Am Ende der innerlichen
        ;            Welt !! " Hilfe 
        ;
        TITLE kmint
        .Model Large
        .386
        .code
        ;
spkm    proc
        push    dx              ; Save dx
        push    di              ; Save di
        push    si              ; Save si
        push    sp              ; Save sp
        ;
        ;
        cmp     ebx,0           ; Init ?
        jnz     spi_ra          ; NO, check next !
        mov     dx,303H         ; dx points to Base-Address
        mov     al,10001010B    ; Set A_port=out, B_port=in, C_port=out
        out     dx,al           ;   and INIT.
        mov     dx,302H         ; dx points to C_PORT
        mov     al,0H 
        out     dx,al           ; Clear  C_PORT
        jmp     abo   
        ;
spi_ra: mov     dx,302H         ; dx points to C_PORT
        in      al,dx           ; Get contens from C_PORT
        ;
        cmp     ebx,1           ; Spindelantrieb RECHTS an ?
        jne     spi_rs          ; NO, check next ! 
        or      al,00000001B    ; SET
        out     dx,al           ;
        jmp     abo
        ;
spi_rs: cmp     ebx,2           ; Spindelantrieb RECHTS aus ?
        jne     spi_la          ; NO, check next !
        and     al,11111110B    ; CLEAR
        out     dx,al
        jmp     abo
        ;
spi_la: cmp     ebx,3           ; Spindelantrieb LINKS an ?
        jne     spi_ls          ; NO, check next !
        or      al,00000010B    ; SET
        out     dx,al
        jmp     abo
        ;
spi_ls: cmp     ebx,4           ; Spindelantrieb LINKS aus ?
        jne     kue_an          ; NO, check next !
        and     al,11111101B    ; CLEAR
        out     dx,al
        jmp     abo
        ;
kue_an: cmp     ebx,5           ; Kuehlmittelantrieb  an ?
        jne     kue_au          ; NO, Check next !
        or      al,00000100B    ; SET
        out     dx,al
        jmp     abo
        ;
kue_au: cmp     ebx,6           ; Kuehlmittelantrieb  aus ?
        jne     ioff            ; NO, check next !
        and     al,11111011B    ; CLEAR
        out     dx,al
        jmp     abo             ; SET-sequenze
        ;
ioff:   cmp     ebx,7           ; Interrups off ?
        jne     ion             ; NO, check next !
        cli                     ; Disable Interrupts
        jmp     abo             ;  and exit.
        ;
ion:    sti                     ; Enable Interrupts !      
        ;
abo:    pop     sp              ; Restore sp - register
        pop     si              ; Restore si - register
        pop     di              ; restore di - register
        pop     dx              ; restore dx - register
        ret
spkm    endp
        ;
        end
